# Metrics


## Basic statistics

- `stats`: (**per-variable statistics**):
  - **Number of texts**:
  - **Average text length**:
  - **Number of words**:
  - **Vocabulary size**:
  - **Number of duplicates**:
- `freq` (**frequency**): ...


## Lexical variation metrics

- `ttr` (**type-token ratio**): ... [(Johnson, 1944)](https://psycnet.apa.org/doiLanding?doi=10.1037%2Fh0093508)
- `root_ttr` (**root type-token ratio**): or Guiraud's index ... [(Guiraud, 1960)](https://link.springer.com/book/9789027700254)
- `log_ttr` (**log type-token ratio**): or Herdan's C ... [(Herdan, 1960)](https://books.google.it/books?id=wfj2zQEACAAJ)
- `maas` (**Maas' index**): ... [(Maas, 1972)](#)


## Text-variables association metrics

- `pmi` (**pointwise mutual information [PMI]**): ...
- `n_pmi` (**normalized PMI**): ...
- `p_pmi` (**positive PMI**): ...
- `np_pmi` (**normalized positive PMI**): ...
- `w_pmi` (**weighted PMI**): ...
- `nw_pmi` (**normalized weighted PMI**): ...
- `pw_pmi` (**positive weighted PMI**): ...
- `npw_pmi` (**normalized positive weighted PMI**): ...
- `np_relevance` (**normalized positive class relevance**): ...
- `nw_relevance` (**normalized weighted class relevance**): ...
- `npw_relevance` (**normalized positive weighted class relevance**): ...
- `lex_art` (**lexical artifacts**): ... as implemented in [Ramponi and Tonelli (2022)](https://aclanthology.org/2022.naacl-main.221/)